#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <string.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>
#define MAXHOSTNAME 80
#define BUFSIZE 1024

char buf[BUFSIZE];
char rbuf[BUFSIZE];

  struct sockaddr_in server;
  struct hostent *hp, *gethostbyname();
  struct servent *sp;
  struct sockaddr_in from;
  struct sockaddr_in addr;
  int fromlen;
  int length;
  int rc, cc;
  char *t1="USMhost v1.0\n\n";
  char *t2=" Nmaquina      IP         NOMBRE                       Multihosting\n";
  char *t3=" ===================================================================\n";
  char *t4="Creado por Sergio Correa: mailto:sergio_correa@mixmail.com";
  char *t5="(NDR)soft  ----  Ningun Derecho Reservado";
  char ThisHost[80];
  char *ip[80];
  char *buff[80];
  int numero;
  char *direccion;
  FILE *archivo,*grabar,*leer;
  char _maquina[100];


void buscar_localhost()
{
  gethostname(ThisHost, MAXHOSTNAME);
  system("clear");
  printf("Bienvenido!\n Estas corriendo usmhost v1.0\n\n");

  printf("Estas conectado en la maquina: %s\n", ThisHost);  /* entrega en pantalla el nombre dela maquina que uno esta usando */

  if  ( (hp = gethostbyname(ThisHost)) == NULL ) {
    fprintf(stderr, "No puedo encontrar la maquina local: %s\n", ThisHost);
    exit(-1);
  }
  bcopy ( hp->h_addr, &(server.sin_addr), hp->h_length);
  printf("    Su direccion IP es: %s \n", inet_ntoa(server.sin_addr));  /* transforma el numero a un string */

}

void genera_maquina(char *_ip)
{

  int i=0,num,temp,decenas=0,unidades=0,largo;
  char *ip_temp,*ip_buscar,tmp[20];

   ip_buscar=strtok(_ip,"*");
   for(num=1;num<256;num++){
        fputs(_ip,archivo);
        temp=num;
        if((temp<200) && (temp>99)){
                   fputc('1',archivo);
                   temp-=100;
        }

        if((temp<256) && (temp>199)) {
                   fputc('2',archivo);
                   temp-=200;
        }
        unidades=temp;

        while(unidades>=10){
             decenas++;
             unidades-=10;
        }
        fputc(48+decenas,archivo);
        fputc(48+unidades,archivo);
        decenas=0;
        fputs("\n",archivo);
   }
}


void leer_archivo_ip_txt()
{

        int c,i;
        FILE *arch_ent,*fopen();
        char linea[140];

        archivo=fopen("maquinas.ip","w");
        if ((arch_ent=fopen("ip.txt","r"))==NULL)
        {
                printf(" Imposible abrir ip.txt \n");
                exit(1);
        }
        numero=0; /*inicializa los mensaje en 0*/

        while (fgets (linea, sizeof (linea), arch_ent) != NULL) {
                      if (linea[0]!='#'){
                                                          /* aca comienza a leer archivo y descarta las lineas de comentario */
                         ip[numero]=strtok(linea,"\n");
                         genera_maquina(ip[numero]);
                         numero++;                                          /* determina cuantas lineas valida hay! */
                      }
        }
        fclose(arch_ent);
      fclose(archivo);
}


void contactar_maquinas()
{
     char linea[20],_maquina[20];
     int maquinas=0,total=0;
     char **q;

     leer=fopen("maquinas.ip","r");
     grabar=fopen("name.txt","w");
     printf("%s",t1);
     fputs(t1,grabar);
     sleep(2);
     printf(" BUSCANDO...\n");
     sleep(3);
     printf("%s",t2);
     fputs(t2,grabar);
     printf("%s",t3);
     fputs(t3,grabar);
     sleep(3);

     while ((fgets (linea, sizeof (linea), leer)) != NULL) {

                 maquinas++;
                 total++;

                 direccion=strtok(linea,"\n");

                 addr.sin_addr.s_addr = inet_addr(direccion);

                 if ((hp = gethostbyaddr((void *)&addr.sin_addr.s_addr,sizeof(addr.sin_addr.s_addr),AF_INET)) == NULL) {
                                           maquinas--;
                 }
                 else {
                        strcpy(_maquina,"  ");
                        strcat(_maquina,direccion);
                        strcat(_maquina," ----> ");
                        strcat(_maquina,hp->h_name);
                        strcat(_maquina,"\n");
                        fputs(_maquina,grabar);
         		printf("%4d.- %s",maquinas,_maquina);

   			/* Imprime los alias que encuentre en la estructura  */
			for ( q = hp->h_aliases; *q!=NULL; q++ ){
               		              printf("ALIAS= %s\n ",*q);
                                      fputs("  ALIAS= ",grabar);
                                      fputs(*q,grabar);
                                      fputs("\n",grabar);
        	        }
                 }
     }

     fclose(grabar);
     fclose(leer);
     printf("\n * FIN de programa... ahora puede revisar el archivo name.txt\n ");
     printf("\n * Se revisaron %d maquinas de las cuales solo %d se pudieron identificar\n",total,maquinas);
     system("rm maquinas.ip");
}

main()
{
    int k;
    buscar_localhost();       /* busca la identidad de la maquina */
    leer_archivo_ip_txt();  /* lee el archivo ip.txt, donde esta la informacion de las direcciones ip a buscar  */
                            /* y las direcciones ip las deja en un buffer */
    contactar_maquinas();
}